%Generating fund alphas for mutual funds

clear all

%Load input file (fund id, time, fund returns, mktrf, smb, hmm, mom, rf)
%The data come from WRDS
%The three output files are subsequently merged and converted into data file %fundalphas.dta

load fundrsq_new.txt
data=fundrsq_new;

clear fundrsq_new

data=sortrows(data,[1 2]);

N=data(end,1); %Number of funds
T=max(data(:,2)); %Number of time periods
CAPM=ones(N,T-11)*(-99); %CAPM alpha
FF=ones(N,T-11)*(-99); %3-factor alpha
CAR=ones(N,T-11)*(-99); %4-factor alpha

exret=data(:,3)-data(:,8);

for i=1:N
    i
    clear a A
    a=find(data(:,1)==i);
    A=data(a,:);
    for t=1:T-11
        clear b B a1 a2 a3 exret
        b=find(A(:,2)>=t&A(:,2)<=t+11);
        if (length(b)>=9 & A(b(end),2)==t+11)
            B=A(b,:);
            exret=B(:,3)-B(:,8);
            c=length(B(:,1));
            a1=regress(exret,[ones(c,1) B(:,4)]);
            a2=regress(exret,[ones(c,1) B(:,4:6)]);
            a3=regress(exret,[ones(c,1) B(:,4:7)]);
            CAPM(i,t)=a1(1);
            FF(i,t)=a2(1);
            CAR(i,t)=a3(1);
        else
            continue
        end;
    end;
 end;

CAPM=CAPM';
CAPM=CAPM(:);

for i=1:N
   CAPM((i-1)*(T-11)+1:i*(T-11),2)=ones(T-11,1)*i;
   CAPM((i-1)*(T-11)+1:i*(T-11),3)=(12:1:T)';
end;

FF=FF';
FF=FF(:);

for i=1:N
   FF((i-1)*(T-11)+1:i*(T-11),2)=ones(T-11,1)*i;
   FF((i-1)*(T-11)+1:i*(T-11),3)=(12:1:T)'; 
end;

CAR=CAR';
CAR=CAR(:);

for i=1:N
   CAR((i-1)*(T-11)+1:i*(T-11),2)=ones(T-11,1)*i;
   CAR((i-1)*(T-11)+1:i*(T-11),3)=(12:1:T)'; 
end;

save capmfund_new.txt CAPM -ascii -tabs

save fffund_new.txt FF -ascii -tabs

save carfund_new.txt CAR -ascii -tabs

%quit;