%This file generates Ftiming (RAI) measure using the input of lagged weights and 
%industrial production growth. The output file in text format is subsequently %converted into a Stata format (covindeps.m)

clear all
load macro1.txt
 
data=macro1;
clear macro1
 
N=max(data(:,1))
T=max(data(:,2))
K=N*(T-11);

covs=ones(K,3)*(-99);

clear K

for i=1:N
     clear a A
     i
     a=find(data(:,1)==i);
     A=data(a,:);
       for t=1:T-11
         clear B b c
         c=find(A(:,2)>=t & A(:,2)<=t+11);
         if length(c)>15
           B=A(c,:);
           covs((i-1)*(T-11)+t,1)=i;
           covs((i-1)*(T-11)+t,2)=t+11;
           b=cov(B(:,3),B(:,4));
           covs((i-1)*(T-11)+t,3)=b(1,2);
         else
           continue
         end;
      end;
end;
 
save covsindeps.txt covs -ascii -tabs

quit;
