*Generating the stock-evel data for the CLMX robustness test (main output file: idioaggstock_2608.dta)
*Data include permno, date, mktcap, mktrf, smb, hml, mom, exret 

clear all

*Loading stock level data from CRSP (permno, date, prc, shrout, dlprc, dlret, ret, shrcd)
use "/Users/mkacperc/Stijn/Revision/Data/stockreturns26_08.dta"

gen year=year(date)
gen month=month(date)

gen yearm=year*100+month
drop year month

replace shrout=. if shrout==0

*Controllling for delisting bias
replace ret=dlret if ret==. & dlret~=.
replace prc=dlprc if prc==. & dlprc~=.

replace prc=. if prc==0
replace prc=abs(prc)

drop dlret dlprc date shrcls

*Keeping ordinary shares
keep if shrcd==10 | shrcd==11

drop shrcd

*Generating market cap of stocks
gen size=prc*shrout
gen lnsize=ln(size)

drop prc shrout

drop if ret==.

*Merging in the factor data (obtained from WRDS)
sort yearm
merge yearm using "/Users/mkacperc/Stijn/Revision/Data/factors.dta",nokeep

tab _merge
drop _merge

drop if mktrf==.
replace rf=rf/100
replace mktrf=mktrf/100
replace smb=smb/100
replace hml=hml/100
replace mom=mom/100

gen exret=ret-rf

save "/Users/mkacperc/Stijn/Revision/Data/temp26_08.dta",replace

keep permno
duplicates drop
sort permno
egen id=seq()

sort permno
save "/Users/mkacperc/Stijn/Revision/Data/id26_08.dta",replace

clear

use "/Users/mkacperc/Stijn/Revision/Data/temp26_08.dta"
sort permno
merge permno using "/Users/mkacperc/Stijn/Revision/Data/id26_08.dta",nokeep

tab _merge
drop _merge

sort id time

save "/Users/mkacperc/Stijn/Revision/Data/idioaggstock_2608.dta",replace

keep id time exret mktrf

outsheet using "/Users/mkacperc/Stijn/Revision/Data/stockrsq.txt",nonames nolabel
